/*
 * Copyright (c) 1999 - 2001, Artur Merke <amerke@ira.uka.de> 
 *
 * This file is part of FrameView2d.
 *
 * FrameView2d is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * FrameView2d is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FrameView2d; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef _ANGLE_H_
#define _ANGLE_H_

#include <math.h>
#include <iostream>

class Angle {
  friend ostream& operator<< (ostream&,const Angle&);
  friend istream& operator>> (istream&,Angle&);
  friend double cos(const Angle &);
  friend double sin(const Angle &);
  friend Angle operator+(const Angle &, const Angle &);
  friend Angle operator-(const Angle &, const Angle &);
  double ang; 
  static const double TwoPi= 2*M_PI;
  //important class invariant:  0.0 <= ang < 2*PI
 public:
  Angle();
  Angle( const Angle& );
  Angle( double );
  double get_value() const { return ang; }
  void set_value(double);
};

#endif

