#include <stdio.h>			
#include <stdlib.h>			
#include <string.h>	
#include <fstream.h>		
#include <strstream.h>
#include "udpsocket.h"			
#include "valueparser.h"
//#include "randomize.h"

#include <unistd.h> // wegen {u}sleep()

void move_ascii_tree_input(UDPsocket & sock) {
  //init_drand();
  float angle[10];
  const float a= 0.22;
  const float b= 0.36;
  const float c= 0.46;
  
  float range[10][2]= { { a,-a},
		       {0.78+b,0.78-b},{b,-b},{-0.78+b,-0.78-b},
		       {0.52+c,0.52-c},{-0.52+c,-0.52-c},
		       {0.52+c,0.52-c},{-0.52+c,-0.52-c},
		       {0.52+c,0.52-c},{-0.52+c,-0.52-c} };

  for (int i=0; i<10; i++) 
    angle[i]= 0.5*( range[i][0]+range[i][1] );

  static char buf_main[200] ;
  ostrstream o(buf_main,200);
  for (;;) 
    for (int t=1; t<= 50; t++) {
      o.seekp(0);
      usleep(100000);
      for (int i=0; i< 10; i++) {
	float max= range[i][0];
	float min= range[i][1];
	float ang;
	//ang= min + (max-min)*float(t)/50.0;
	ang= angle[i];
	float s= drand48();
	if (s < 0.5)
	  s= (max-min)/50.0;
	else
	  s= -(max-min)/50.0;
	ang+= s;
	if (ang > max)
	  ang= max;
	else if (ang < min)
	  ang= min;
	o << "MOV " << i+1 << "(" <<  ang  << ")";
	angle[i]= ang;
      }
      o << '\0';
      sock.send_msg(o.str(), o.pcount() );
      //cout << "\n" << o.pcount() << " bytes\n" << o.str();
    }
}


void loop_input(UDPsocket & sock) {
  for (;;) 
    for (int t=1; t<= 50; t++) {
      usleep(50000);
#if 0
      char buf_main[100] ;
      ostrstream o(buf_main,100);
#else
      ostrstream o;
#endif
      o << "MOV 1 (" << 6.28 * float(t)/50 << ")";
      sock.send_msg(o.str(), o.pcount() );
      //cout << "\n" << o.pcount() << " bytes";
    }
}

void file_input(UDPsocket & sock, const char * fname) {
  ifstream  in(fname);
  if (!in) {
    cerr << "\nproblems with reading file " << fname;
    exit(1);
  }
  char send_buffer[1026];
  send_buffer[0]= '[';
  send_buffer[1]= ']';
  
  char *buffer= send_buffer+2;

  while ( in ) {
    in.getline(buffer,1023);
    char *dum= buffer;
    while (*dum == ' ')
      dum++;
    if (*dum == '#' || *dum == '\0')
      continue;
    cout << "\nsending \"" << send_buffer << "\"";
    sock.send_msg(send_buffer,strlen(send_buffer));
  }
}

void command_line_input(UDPsocket & sock) {
  char buffer[1024];
  while (1) {
    cout << "\n>";
    cin.getline(buffer,1023);
    if (*buffer== 'q')
      return;
    else {
      cout << "\nsending \"" << buffer << "\"";
      sock.send_msg(buffer,strlen(buffer));
    }
  }
}

void middle_size_input(UDPsocket & sock) {

}

#define HALMA
#ifdef HALMA
const int initialGrid[19][19]=
  {
        /* ------                    columns                ---------- */
             /* 0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8 */
    /*   0 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
    /*   1 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 2,-1,-1,-1,-1,-1},
    /*   2 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 2, 2,-1,-1,-1,-1,-1},
    /* r 3 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 2, 2, 2,-1,-1,-1,-1,-1},
    /* o 4 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 2, 2, 2, 2,-1,-1,-1,-1,-1},
    /* w 5 */  {-1,-1,-1,-1,-1, 0, 0, 0, 0, 2, 2, 2, 2, 2, 0, 0, 0, 0,-1},
    /* s 6 */  {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1},
    /*   7 */  {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1},
    /*   8 */  {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1,-1},
    /*   9 */  {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1,-1,-1},
    /*   0 */  {-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1,-1,-1},
    /*   1 */  {-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1,-1,-1},
    /*   0 */  {-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1,-1,-1,-1},
    /*   3 */  {-1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0,-1,-1,-1,-1,-1},
    /*   4 */  {-1,-1,-1,-1,-1, 1, 1, 1, 1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
    /*   5 */  {-1,-1,-1,-1,-1, 1, 1, 1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
    /*   6 */  {-1,-1,-1,-1,-1, 1, 1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
    /*   7 */  {-1,-1,-1,-1,-1, 1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
    /*   8 */  {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
  };

class HalmaBoard  {
  int XCENTER;  // Zentrum des Spielbrettes
  int YCENTER;  //
  int chRadius; //radius of a checker

  static const int BSIZE   = 19;
 public:  
  HalmaBoard(int size);
  void MatrixRC_2_ScreenXY(int row, int col, double & x, double & y);
};    

HalmaBoard::HalmaBoard(int size) {
  XCENTER = 0;  //300
  YCENTER = 0;  //350
  chRadius = size/35;
}

void HalmaBoard::MatrixRC_2_ScreenXY(int row, int col, double & x, double & y) {    
  int LY_offset, LX_offset;
  int bx= col;
  int by= row;
  
  LX_offset = ( bx - 9 );
  LY_offset = ( by - 9 );
  
  x = XCENTER + LX_offset * 2*chRadius + LY_offset * chRadius;
  y = YCENTER - LY_offset * 2*chRadius;
}

void halma_input(UDPsocket & sock) {
  HalmaBoard hb(100);
   
#define c_black "000000"
#define c_red   "ff0000"
#define c_blue  "0000ff"
#define c_green "00ff00"
  char color[7][8] = { c_black, c_red, c_blue , c_green, c_red, c_blue,  c_black};

  ostrstream o;
  int num_circles= 0;
  //field
  o << "VA (0,0,80,80) EMP 0";
  o << "\nINS CIRCLE col=" << c_black << " ";

  for (int row=0; row < 19; row++) 
    for (int col=0; col < 19; col++) {
      double cx,cy;
      hb.MatrixRC_2_ScreenXY(row,col,cx,cy);
      const int idx= initialGrid[row][col];
      if ( idx >= 0 ) {
	o << "\n  (" << cx << "," << cy << "," << 100.0/55.0 << ")";
	num_circles++;
      }
    }

#if 1
  for (int row=0; row < 19; row++) 
    for (int col=0; col < 19; col++) {
      double cx,cy;
      hb.MatrixRC_2_ScreenXY(row,col,cx,cy);
      const int idx= initialGrid[row][col];
      if ( idx > 0) {
	int frame= row*19+col+1;
	o << "\nINS FRAME id=" << frame << " (" << cx << "," << cy << ")"
	  << "\n  INS " << frame << " CIRCLE fil=1 col=" << color[idx] << " (0,0," << 100.0/60.0 <<")";
      }
    }
#endif
  sock.send_msg(o.str(), o.pcount() );
  cout << o.str();
  cout << "\nsize= " << o.pcount() << ", num_circles= " << num_circles << endl;
  
}

#endif

int  main (int  argc,char  *argv[]) {    
  if (argc <= 1) {
    cerr << "\nno arguments specified";
    return 1;
  }
  else {
    argc--;
    argv++;
  }
  bool halma= false;
  bool command_line= false;
  bool loop= false;
  bool move_ascii_tree= false;
  char file[255];

  ValueParser vp(argc,argv);
  if ( vp.get("halma",halma) == 0 ) halma= true;
  if ( vp.get("c",command_line) == 0 ) command_line= true;
  if ( vp.get("loop",loop) == 0 ) loop= true;
  if ( vp.get("tree",move_ascii_tree) == 0 ) move_ascii_tree= true;
  vp.get("file",file,255,"");

  UDPsocket sock;
  sock.init_socket_fd();
  sock.init_serv_addr("localhost",6010);

  if (command_line)
    command_line_input(sock);
  else if (move_ascii_tree)
    move_ascii_tree_input(sock);
  else if (loop) 
    loop_input(sock);
  else if (halma)
    halma_input(sock);
  else if ( strlen(file) ) 
    file_input(sock,file);
  
  

  return 0;
}
