/*
 * Copyright (c) 1999 - 2001, Artur Merke <amerke@ira.uka.de> 
 *
 * This code is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * It is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */
#ifndef _STRCONV_H_
#define _STRCONV_H_

/*skips whole words, after the expression there must be a white space or an end in str*/
int strskip(char const* str,char const* expr, char const* & next);

/*skips just the expression, regardless of what follows in str*/
int strshift(char const* str,char const* expr, char const* & next);

/*the value of the specific type must be followed by a white char or string end
 for example 1,2,3 will be not recognized*/
int strconv(char const* str,int & val, char const* & next);
int strconv(char const* str,long & val, char const* & next);
int strconv(char const* str,double & val, char const* & next);
int strconv(char const* str,float & val, char const* & next);
int strconv(char const* str,bool & val, char const* & next);

/*the value of the specific type might be followed by some non white space char
 for example 1,2,3 will be recognized as 1 and pointer on the first ',' will be returned*/
int substrconv(char const* str,int & val, char const* & next);
int substrconv(char const* str,long & val, char const* & next);
int substrconv(char const* str,double & val, char const* & next);
int substrconv(char const* str,float & val, char const* & next);
int substrconv(char const* str,bool & val, char const* & next);


/* all following variants allow not to care about the next pointer */
inline int strskip(char const* str,char const* expr) {
  char const* dum;
  return strskip(str,expr,dum);
}

inline int strshift(char const* str,char const* expr) {
  char const* dum;
  return strshift(str,expr,dum);
}

inline int strconv(char const* str_and_next,int & val) {
  char const* dum;
  return strconv(str_and_next,val,dum);
}

inline int strconv(char const* str_and_next,long & val) {
  char const* dum;
  return strconv(str_and_next,val,dum);
}

inline int strconv(char const* str_and_next,double & val) {
  char const* dum;
  return strconv(str_and_next,val,dum);
}

inline int strconv(char const* str_and_next,float & val) {
  char const* dum;
  return strconv(str_and_next,val,dum);
}

inline int strconv(char const* str_and_next,bool & val) {
  char const* dum;
  return strconv(str_and_next,val,dum);
}

#endif
